#include <stdio.h>
#include <stdlib.h>
#include <math.h>

double Func(double x, double y){
	return 1/cos(x) - y*tan(x); 
}

double Exact(double x){
	return sin(x) + cos(x); 
}

double kuttaMerson(double a, double y_0, double b, double (*Func)(double x, double y), double epsilon){
	double k1, k2, k3, k4, k5;
	int i, condition;
	double x , y,  error, R;
	double h = b-a;
	x = a;
	y = y_0;
	
	FILE *f = fopen("data.txt", "w");
    if (f == NULL) {
        printf("Error opening file!\n");
        return 1;
    }
        
	while (x <= b){
		do {
            k1 = Func(x, y);
			k2 = Func(x + h/3, y + h*k1/3);
			k3 = Func(x + h/3, y + h*k1/6 + h*k2/6);
			k4 = Func(x + h/2, y + h*k1/8 + 3*h*k2/8);
			k5 = Func(x + h, y + h*k1/2 - 3*h*k3/2 +2*h*k4);
			R = fabs(2*k1 - 9*k3 + 8*k4 - k5)*h/30; 
            if (R > epsilon) {
                    h /= 2;
                }
            } while (R > epsilon);
            y += (k1 + 4 * k4 + k5)*h / 6;
            x += h;
            fprintf(f, "%.15f %.15f\n", x, h);
            if (R < epsilon / 64) {
                h *= 2;
            }
        }
        fclose(f);
	return fabs(y - Exact(x));
}

int main(){    
    int i;
    double eps = 0.000001;
    double error, h;
    double a = 0;
    double b = 1.5;
    double y_0 = 1;  
    
    for(i = 0; i<1; i++){
    	error = kuttaMerson(a,y_0,b,Func,eps); 	
		eps = eps*0.1; 
	}    
    return 0;    
}