#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include<time.h>

void Func(double x, double y[2], double perturbation, double y_temp[2]){
	y_temp[0] = y[1];
	
	perturbation = 1.0 - (double)rand() / RAND_MAX * 0.01*perturbation;
	y_temp[1] = perturbation*(x+2*y[0])/pow(cos(x),2) - x*y[1]; 	
} 

double Exact(double x){
	return tan(x); 
}

int ShootingMethod(double a, double b, double ya, double yb, double epsilon, double *k, double per, double xk[1000], double yk[1000]){
	int i;
	int n = 0;
	double C1 = -1.0;
	double C2 = 0;
	double x, g_prev, g, C;
	double h = (b-a);
	double error = 0.0;
	double k1[2], k2[2], k3[2], k4[2], k5[2], y[2], y_temp[2];
	
	x = a;
	y[0] = ya;
	y[1] = C1;
	while(x + h <= b){								
        Func(x, y, per, k1);
		
		for(i = 0; i<2; i++) y_temp[i] = y[i] + h*k1[i]/3;            
		Func(x + h/3, y_temp, per, k2);
			
		for(i=0; i<2; i++) y_temp[i] = y[i] + h*k1[i]/6 + h*k2[i]/6;
		Func(x + h/3, y_temp, per, k3);
			
		for(i = 0; i<2; i++) y_temp[i] = y[i]+ h*k1[i]/8 + 3*h*k2[i]/8;
		Func(x + h/2, y_temp, per, k4);
			
		for(i = 0; i<2; i++) y_temp[i] = y[i] + h*k1[i]/2 -3*h*k3[i]/2 + 2*h*k4[i];
		Func(x + h, y_temp , per, k5);
	
        for(i = 0; i<2; i++) y[i] += (k1[i] + 4 * k4[i] + k5[i])*h / 6;
        x += h;		
	}
	g_prev = yb - y[0]; 

	while (1){
		x = a;
		y[0] = ya;
		y[1] = C2;
		while(x + h <= b){
		    do{		    						
		        Func(x, y, per, k1);
			
				for(i = 0; i<2; i++) y_temp[i] = y[i] + h*k1[i]/3;            
				Func(x + h/3, y_temp, per, k2);
					
				for(i=0; i<2; i++) y_temp[i] = y[i] + h*k1[i]/6 + h*k2[i]/6;
				Func(x + h/3, y_temp, per, k3);
					
				for(i = 0; i<2; i++) y_temp[i] = y[i]+ h*k1[i]/8 + 3*h*k2[i]/8;
				Func(x + h/2, y_temp, per, k4);
					
				for(i = 0; i<2; i++) y_temp[i] = y[i] + h*k1[i]/2 -3*h*k3[i]/2 + 2*h*k4[i];
				Func(x + h, y_temp , per, k5);
				h/=2;
			}while (fabs(2*k1[1] - 9*k3[1] + 8*k4[1] - k5[1])*h/30 > epsilon);
			h *=2;
		    
	        for(i = 0; i<2; i++) y[i] += (k1[i] + 4 * k4[i] + k5[i])*h / 6;
	        x += h;	
	        xk[n] = x;
			yk[n] = y[0];
			n+=1;
	        
	        //if(fabs(2*k1[1] - 9*k3[1] + 8*k4[1] - k5[1])*h/30 > epsilon) h/=2;
		}
		if (fabs(y[0] - yb) <= epsilon) break;
		else {
			g = yb - y[0];
			C = C2;
			C2 = C2 - g*(C2 - C1)/(g - g_prev);
			C1 = C;
			g_prev = g;
			error = 0.0;
			n = 0;
		}
	}
	(*k) = h;
	return n;
}
int main() {
    int i, j, n, k;
    double eps = 0.1;
    double error, h = 0.25;
    double a = 0;
    double b = 1;
    double ya = 0;  
    double yb = tan(1);
    double xk[1000], yk[1000];
    double x;
    
    FILE *f = fopen("data.txt", "w");
    if (f == NULL) {
        printf("Error opening file!\n");
        return 1;
    } 
    for(i = 0; i<9; i++){
    	error = 0.0;
    	n = ShootingMethod(a, b, ya, yb, eps, &h, 0.0, xk, yk);
    	for (j = 0; j<n; j++) if (fabs(yk[j] - Exact(xk[j]))>error) error = fabs(yk[j] - Exact(xk[j]));
    	fprintf(f, "%.15f %.15f %.15f\n", error, eps, h);
		eps = eps*0.1; 
	} 
	 
	eps = 0.001;
    srand(time(NULL));
    for (i = 1; i< 6; i++){
    	for(j = 0; j<20; j++){    		
    	    error = 0.0;
    	    x = a;
	    	n = ShootingMethod(a, b, ya, yb, eps, &h, i, xk, yk);
	    	for (k = 0; k<n; k++) 
				if (fabs(yk[k] - Exact(xk[k]))>error) {
					error = fabs(yk[k] - Exact(xk[k]));
					x = xk[k];
				}
	    	fprintf(f, "%.15f ", error/Exact(x));
	    }
		fprintf(f,"\n");  
	}
	fclose(f);
    return 0;    
}
